/* -- AMD -- */
#define PCI_VENDOR_ID_AMD               0x1022
#define PCI_DEVICE_ID_AMD_LANCE         0x2000
/* -- Intel -- */
#define PCI_VENDOR_ID_INTEL             0x8086
#define PCI_DEVICE_ID_INTEL_82557       0x1229
#define PCI_DEVICE_ID_INTEL_82559ER     0x1209
#define PCI_DEVICE_ID_INTEL_ID1029      0x1029
#define PCI_DEVICE_ID_INTEL_ID1030      0x1030
#define PCI_DEVICE_ID_INTEL_82562       0x2449

/* macros for PCI BIOS */
#define PCI_VENDOR_ID           0x00    /* 16 bits */
#define PCI_DEVICE_ID           0x02    /* 16 bits */
#define PCI_COMMAND             0x04    /* 16 bits */

#define PCI_CLASS_CODE          0x0b    /* 8 bits */
#define PCI_SUBCLASS_CODE       0x0a    /* 8 bits */
#define PCI_HEADER_TYPE         0x0e    /* 8 bits */

#define PCI_BASE_ADDRESS_0      0x10    /* 32 bits */
#define PCI_BASE_ADDRESS_1      0x14    /* 32 bits */
#define PCI_BASE_ADDRESS_2      0x18    /* 32 bits */
#define PCI_BASE_ADDRESS_3      0x1c    /* 32 bits */
#define PCI_BASE_ADDRESS_4      0x20    /* 32 bits */
#define PCI_BASE_ADDRESS_5      0x24    /* 32 bits */

#define PCI_BASE_ADDRESS_IO_MASK       (~0x03)
#define PCI_BASE_ADDRESS_SPACE_IO      0x01
#define PCI_ROM_ADDRESS                0x30    /* 32 bits */
#define PCI_INTERRUPT_LINE             0x3c    /* 8 bits */
#define PCI_INTERRUPT_PIN              0x3d    /* 8 bits */

#define PCI_FUNC(devfn)                ((devfn) & 0x07)
#define CONFIG_CMD(bus, device_fn, where) \
        (0x80000000 | (bus << 16) | (device_fn << 8) | (where & ~3))
#define PCI_COMMAND_MASTER             0x4     /* Enable bus mastering */
#define PCIBIOS_SUCCESSFUL             0x00

#define ROM_INFO_LOCATION              0x7dfa
struct rom_info {
        unsigned short  rom_segment;
        unsigned short  rom_length;
};

struct pci_device {
  unsigned short  vendor, dev_id;
  const char      *name;
  unsigned int    membase;
  unsigned short  ioaddr;
  unsigned char   irq;
  unsigned char   devfn;
  unsigned char   bus;
  short           suffix;
};

/* for detecting PCI BIOS information */
_PROTOTYPE( void scan_bus, (struct pci_device *pcidev)                  );
_PROTOTYPE( int pcibios_read_config_byte,
	    (unsigned int bus, unsigned int device_fn,
	     unsigned int where, unsigned char *value)                  );
_PROTOTYPE( int pcibios_read_config_word,
	    (unsigned int bus, unsigned int device_fn, 
	     unsigned int where, unsigned short *value)                 );
_PROTOTYPE( int pcibios_read_config_dword,
	    (unsigned int bus, unsigned int device_fn,
	     unsigned int where, unsigned int *value)                   );
_PROTOTYPE( int pcibios_write_config_word,
	    (unsigned int bus, unsigned int device_fn,
	     unsigned int where, unsigned short value)                  );
#if 0
_PROTOTYPE( unsigned int in_long, (port_t port)                  );
_PROTOTYPE( void out_long, (port_t port, unsigned int value)     );
#endif
